/*
 * Copyright (c) 2008, Pierre-Alexandre LOUYOT
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the website errant.fr nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Pierre-Alexandre LOUYOT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Pierre-Alexandre LOUYOT BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <string.h>
#include "step.h"

static int	read_from_file(int fd)
{
  in_buf = read(fd, buff, BUFF_SIZE);
  start = 0;
  return (in_buf);
}

static char	*add_to_line(char *line,int cur)
{
  char		*new;
  int		old_len;

  if ((new = malloc((old_len = (line ? strlen(line) : 0)) + cur + 1)) == NULL)
    my_putstr(2, "Error while allocating memory: exiting!\n");
  if (line)
    {
      memcpy(new,line,old_len);
      free(line);
    }
  memcpy(new + old_len, buff+start, cur);
  new[old_len + cur] = 0;
  start += cur + 1;
  return (new);
}

char	*get_next_line(int fd)
{
  int	cur;
  char	*line;

  for (line = 0, cur = 0; ; cur++)
    {
      if (start >= in_buf)
	{
	  if (!read_from_file(fd))
	    return (line);
	  cur = 0;
	}
      if (buff[start + cur] == '\n')
	{
	  line = add_to_line(line, cur);
	  return (line);
	}
      if (start + cur == in_buf - 1)
	line = add_to_line(line, cur + 1);
    }
}
