/*
 * Copyright (c) 2008, Pierre-Alexandre LOUYOT
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the website errant.fr nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Pierre-Alexandre LOUYOT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Pierre-Alexandre LOUYOT BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <string.h>
#include "step.h"

/* Function that print a string to stdout or stderr, */
/* depends of the flag fd and returns -1 if stderr is used */
void	my_putstr(int fd, char *str)
{
  write(fd, str, strlen(str));
  if (fd == 2)
    exit (-1);
}

int	main(int argc, char **argv)
{
  char	*line;
  int	fd;
  int	rd;
  char	c;

  if (argc != 2)
    my_putstr(2, "Usage: step file\nWhere file is a shell scripting file to be executed step by step.\nError from user: exiting!\n");
  if ((fd = open(argv[1], O_RDONLY)) == -1)
    my_putstr(2, "Error while opening file: exiting!\n");
  my_putstr(1, "Press Enter (and *only* Enter) to execute your script step by step.\n");
  my_putstr(1, "Everytime you press Enter, it will go one step forward.\n\n");
  while ((rd = read(0, &c, 1024)) >= 0)
    {
      c = '\0';
      if ((line = get_next_line(fd)) == 0)
	{
	  my_putstr(1, "End Of File: exiting!\n--\n");
	  close(fd);
	  free (line);
	  exit(0);
	}
      my_putstr(1, "> \e[1;32m");
      my_putstr(1, line);
      my_putstr(1, "\e[0m\n");
      system(line);
      free(line);
    }
  close (fd);
  return (0);
}
